import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;

public class ArrazTest {

    @Test
    public void testSumIntArray(){
        int[] arr = {1,2,3};

        int expected = 6;
        int actual = Arraz.sumIntArray(arr);

        Assert.assertEquals(expected,actual,.01);
    }

    @Test
    public void testSumDoubleArray(){
        double[] arr = {1.1,2.2,3.3};

        double expected = 6.6;
        double actual = Arraz.sumDoubleArray(arr);

        Assert.assertEquals(expected,actual,.01);
    }

    @Test
    public void test1sumValuesOfArray(){
        int[] arr1 = {1,2,3,4,5};
        int[] arr2 = {2,3,4,5,6};

        int actual = Arraz.sumValuesOf2Array(arr1,arr2);

        int expected = 35;

        Assert.assertEquals(expected,actual,.01);

    }

    @Test
    public void test2sumValuesOfArray(){
        int[] arr1 = {3,3,3};
        int[] arr2 = {4,4,4};

        int actual = Arraz.sumValuesOf2Array(arr1,arr2);
        int expected = 21;

        Assert.assertEquals(actual,expected,.01);
    }

    @Test
    public void test1sumDoublesOfArray(){
        double[] arr1 = {1.1,2.2,3.3};
        double[] arr2 = {4.4,5.5,6.6};

        double expected = 23.1;
        double actual = Arraz.sumDoublesOf2Array(arr1,arr2);

        Assert.assertEquals(expected,actual,.01);
    }


    @Test
    public void test2sumDoublesOfArray(){
        double[] arr1 = {7.7,8.8,9.9};
        double[] arr2 = {10.1,11.11,12.12};

        double expected = 59.73;
        double actual = Arraz.sumDoublesOf2Array(arr1,arr2);

        Assert.assertEquals(expected,actual,.01);
    }

    @Test
    public void test1averageOfArrays(){
        int[] arr = {1,2,3,4,5};

        double expected = 3;
        double actual = Arraz.averageOfArrays(arr);

        Assert.assertEquals(expected,actual,.01);
    }

    @Test
    public void test2averageOfArrays(){
        int[] arr = {6,7,8,9,10};

        int expected = 8;
        int actual = Arraz.averageOfArrays(arr);

        Assert.assertEquals(expected,actual,.01);
    }

    @Test
    public void test1doubleAverageOfArrays(){
        double[] arr = {1.1,2.2,3.3};

        double expected = 2.2;
        double actual = Arraz.doubleAverageOfArrays(arr);

        Assert.assertEquals(expected,actual,.01);
    }

    @Test
    public void test2doubleAverageOfArrays(){
        double[] arr = {4.4,5.5,6.6};

        double expected = 5.5;
        double actual = Arraz.doubleAverageOfArrays(arr);

        Assert.assertEquals(expected,actual,.01);
    }

    @Test
    public void test1containsValue(){
        int[] arr = {1,2,3,4,5};
        int number = 5;


        boolean actual = Arraz.containsValue(arr,number);

        Assert.assertTrue(actual);
    }

    @Test
    public void test2containsValue(){
        int[] arr = {1,2,3,4,5};
        int number = 6;


        boolean actual = Arraz.containsValue(arr,number);

        Assert.assertFalse(actual);
    }

    @Test
    public void test1reverseArray(){
        int[] arr = {1,2,3,4,5,6};

        int[] expected = {6,5,4,3,2,1};
        int[] actual = Arraz.reverseArray(arr);

        Assert.assertEquals(expected[0],actual[0]);



    }

    @Test
    public void test2reverseArray(){
        int[] arr = {1,2,3,4,5,6};

        int[] expected = {6,5,4,3,2,1};
        int[] actual = Arraz.reverseArray(arr);

        Assert.assertEquals(expected[4],actual[4]);



    }

    @Test
    public void test1getOddEvensOfArray(){


        int[] arr = {1,2,3,4,6};

        OddEven expected = new OddEven(3,2);

        OddEven actual = Arraz.getOddEvensOfArray(arr);

        Assert.assertEquals(expected,actual);

    }

    @Test
    public void test2getOddEvensOfArray(){


        int[] arr = {1,5,3,4,7};

        OddEven expected = new OddEven(1,4);

        OddEven actual = Arraz.getOddEvensOfArray(arr);

        Assert.assertEquals(expected,actual);

    }

    @Test
    public void test1findIndexOf(){
        int[] arr = {1,2,3,4,5};

        int expected = 1;

        int actual = Arraz.findIndexOf(arr, 2);

        Assert.assertEquals(expected,actual,.01);
    }

    @Test
    public void test2findIndexOf(){
        int[] arr = {1,2,3,4,5};

        int expected = -1;

        int actual = Arraz.findIndexOf(arr, 6);

        Assert.assertEquals(expected,actual,.01);
    }

    @Test
    public void test1copyArrayByIterator(){
        Integer[] arr = {1,2,3,4,5};

        Integer[] expected = {1,2,3,4,5};

        Integer[] actual = Arraz.copyArrayByIterator(arr);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2copyArrayByIterator(){
        Integer[] arr = {1,2,3,4,5,6,7,8,9};

        Integer[] expected = {1,2,3,4,5,6,7,8,9};

        Integer[] actual = Arraz.copyArrayByIterator(arr);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1copyArrayByLoop(){
        int[] arr = {1,2,3,4,5};

        int[] expected = {1,2,3,4,5};
        int[] actual = Arraz.copyArrayByLoop(arr);

        Assert.assertEquals(expected[1],actual[1]);
    }

    @Test
    public void test2copyArrayByLoop(){
        int[] arr = {11,2,10,4,5};

        int[] expected = {11,2,10,4,5};
        int[] actual = Arraz.copyArrayByLoop(arr);

        Assert.assertEquals(expected[1],actual[1]);
        Assert.assertEquals(expected[2],actual[2]);
        Assert.assertEquals(expected[4],actual[4]);

    }

    @Test
    public void test1removeElementFromArray(){
        int[] arr =  {1,2,3,4,5};

        int[] expected = {1,2,4,5};
        int[] actual = Arraz.removeElementFromArray(arr,3);


        Assert.assertEquals(expected[1],actual[1]);
        Assert.assertEquals(expected[2],actual[2]);
        Assert.assertEquals(expected[3],actual[3]);
        Assert.assertEquals(expected[0],actual[0]);

    }

    @Test
    public void test2removeElementFromArray(){
        int[] arr =  {5,4,3,2,1};

        int[] expected = {5,3,2,1};
        int[] actual = Arraz.removeElementFromArray(arr,4);

        Assert.assertEquals(expected[1],actual[1]);
        Assert.assertEquals(expected[2],actual[2]);
        Assert.assertEquals(expected[3],actual[3]);
        Assert.assertEquals(expected[0],actual[0]);

    }

    @Test
    public void test1insertIntoArrayAt(){
        int[] arr = {1,2,3,5,6};

        int[] expected = {1,2,3,4,6};
        int[] actual = Arraz.insertIntoArrayAt(arr,3,4);

        Assert.assertEquals(expected[3], actual[3]);
        Assert.assertEquals(expected[1], actual[1]);
        Assert.assertEquals(expected[2], actual[2]);
        Assert.assertEquals(expected[4], actual[4]);

    }

    @Test
    public void test2insertIntoArrayAt(){
        int[] arr = {10,20,30,50,60};

        int[] expected = {10,20,30,40,60};
        int[] actual = Arraz.insertIntoArrayAt(arr,3,40);

        Assert.assertEquals(expected[3], actual[3]);
        Assert.assertEquals(expected[1], actual[1]);
        Assert.assertEquals(expected[2], actual[2]);
        Assert.assertEquals(expected[4], actual[4]);

    }

    @Test
    public void test1findMaxMinOfArray(){
        int[] arr = {3,6,8,2,1};

        MaxMin expected = new MaxMin(8,1);
        MaxMin actual = Arraz.findMaxMinOfArray(arr);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2findMaxMinOfArray(){
        int[] arr = {34,16,18,2,11,16,34,2,1,1};

        MaxMin expected = new MaxMin(34,1);
        MaxMin actual = Arraz.findMaxMinOfArray(arr);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1removeDupesFromArray(){
        Integer[] arr = {34,16,18,2,11,16,34,2,1,1};

        Integer[] expected = {1,2,11,16,18,34};
        Integer[] actual = Arraz.removeDupesFromArray(arr);

        Assert.assertEquals(expected,actual);

    }

    @Test
    public void test2removeDupesFromArray(){
        Integer[] arr = {32,26,28,21,21,26,32,2,1,1};

        Integer[] expected = {1,2,21,26,28,32};
        Integer[] actual = Arraz.removeDupesFromArray(arr);

        Assert.assertEquals(expected,actual);

    }

    @Test
    public void test1find2ndLargestValueFromArray(){
        double[] arr = {1.1,2.2,3.3,4.4,5.5,6.6,7.7,8.8,9.9,10.1};

        double expected = 9.9;
        double actual = Arraz.find2ndLargestValueFromArray(arr);

        Assert.assertEquals(expected,actual);

    }

    @Test
    public void test2find2ndLargestValueFromArray(){
        double[] arr = {2.2,3.4,5.6,2.1,3.3,3.4,5.6};

        double expected = 3.4;
        double actual = Arraz.find2ndLargestValueFromArray(arr);

        Assert.assertEquals(expected,actual);

    }

    @Test
    public void test1makeMeAnArrayListFromArray(){
        Object[] array = {1,2,3,4,5,6};


        int expected = array.length;
        ArrayList arrayList = Arraz.makeMeAnArrayListFromArray(array);

        int actual = arrayList.size();

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2makeMeAnArrayListFromArray(){
        Object[] array = {1,2,3,5,6};


        int expected = array.length;
        ArrayList arrayList = Arraz.makeMeAnArrayListFromArray(array);

        int actual = arrayList.size();

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1makeMeAnArrayFromArrayList(){

        ArrayList arrayList = new ArrayList();
        arrayList.add(5);
        arrayList.add(4);
        arrayList.add(6);
        arrayList.add(7);


        Object[] array = Arraz.makeMeAnArrayFromArrayList(arrayList);

        int expected = arrayList.size();
        int actual = array.length;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2makeMeAnArrayFromArrayList(){

        ArrayList arrayList = new ArrayList();
        arrayList.add(5);
        arrayList.add(4);
        arrayList.add(6);
        arrayList.add(7);
        arrayList.add(6);
        arrayList.add(6);
        arrayList.add(6);
        arrayList.add(6);




        Object[] array = Arraz.makeMeAnArrayFromArrayList(arrayList);

        int expected = arrayList.size();
        int actual = array.length;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1check2ArraysForEqual(){

        Object[] arr1 = {1,2,3,4,5};
        Object[] arr2 = {1,2,3,4,5};



       boolean actual = Arraz.check2ArraysForEqual(arr1,arr2);

       Assert.assertTrue(actual);
    }

    @Test
    public void test2check2ArraysForEqual(){

        Object[] arr1 = {1,2,3,4,5};
        Object[] arr2 = {1,2,3,4,5,6};



        boolean actual = Arraz.check2ArraysForEqual(arr1,arr2);

        Assert.assertFalse(actual);
    }

    @Test
    public void test1averageArrayWithoutMaxMin(){

        int[] array = {2,4,6,8,10};

        int expected = 6;
        int actual = Arraz.averageArrayWithoutMaxMin(array);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2averageArrayWithoutMaxMin(){

        int[] array = {2,2,2,2,2,2,4,6,8,10,10,10,10,10};

        int average = Arraz.averageOfArrays(array);
        int sum = Arraz.sumIntArray(array);

        int expected = 6;
        int actual = Arraz.averageArrayWithoutMaxMin(array);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1arrayHas65and77(){

        int[] array = {1,2,3,55,65,77,100};

        boolean has65and77 = Arraz.arrayHas65and77(array);

        Assert.assertTrue(has65and77);

    }

    @Test
    public void test2arrayHas65and77(){

        int[] array = {1,2,3,55,77,100};

        boolean has65and77 = Arraz.arrayHas65and77(array);

        Assert.assertFalse(has65and77);

    }
}